#include "stdafx.h"

#include "sql_facade.h"


using namespace grt;


SqlFacade * SqlFacade::instance_for_db_obj(db_DatabaseObjectRef db_obj)
{
  db_mgmt_RdbmsRef rdbms;

  {
    static db_Table t(db_obj.get_grt());
    static db_View v(db_obj.get_grt());
    static db_Routine r(db_obj.get_grt());
    static db_RoutineGroup rg(db_obj.get_grt());

    if (db_obj.is_instance(t.get_metaclass())
      || db_obj.is_instance(v.get_metaclass())
      || db_obj.is_instance(r.get_metaclass())
      || db_obj.is_instance(rg.get_metaclass()))
    {
      rdbms= db_mgmt_RdbmsRef::cast_from(db_obj->owner()->owner()->owner()->get_member("rdbms"));
    }
  }

  return instance_for_rdbms(rdbms);
}


SqlFacade * SqlFacade::instance_for_rdbms(db_mgmt_RdbmsRef rdbms)
{
  if (rdbms.is_valid())
    return  instance_for_rdbms_name(rdbms->get_grt(), rdbms->name());
  else
    return NULL;
}


SqlFacade * SqlFacade::instance_for_rdbms_name(GRT *grt, const std::string &name)
{
  const char *def_module_name= "SqlFacade";
  std::string module_name= name + def_module_name;
  SqlFacade *module= dynamic_cast<SqlFacade*>(grt->get_module(module_name));
  return module;
}
