#include "stdafx.h"

#include "sqlide.h"


using namespace bec;
using namespace grt;


#define MODULE_VERSION "1.0.0"


GRT_MODULE_ENTRY_POINT(SqlImpl);


#ifdef _WIN32
# define FRONTEND_LIBNAME(obj, windows_dll, linux_so, osx_dylib)\
  obj->moduleName(windows_dll)
#elif defined(__APPLE__)
# define FRONTEND_LIBNAME(obj, windows_dll, linux_so, osx_dylib)\
  obj->moduleName(osx_dylib)
#else
# define FRONTEND_LIBNAME(obj, windows_dll, linux_so, osx_dylib)\
  obj->moduleName(linux_so)
#endif


grt::ListRef<app_Plugin> SqlImpl::getPluginInfo()
{
  grt::ListRef<app_Plugin> list(get_grt());
  GRT *grt= get_grt();
  {
    app_PluginRef plugin(grt);

    FRONTEND_LIBNAME(
      plugin,
      ".\\sqlide.fe.dll",
      "",
      "");
    plugin->pluginType("gui");
    plugin->moduleFunctionName("DbSqlEditor");
    plugin->name("db.sql.editor");
    plugin->caption("SQL Editor");
    plugin->groups().insert("database/Database");

    grt::StringListRef document_types(grt);
    document_types.insert("workbench.Document");
    //plugin->documentStructNames(document_types);

    app_PluginObjectInputRef pdef(grt);
    pdef->objectStructName("db.Catalog");
    plugin->inputValues().insert(pdef);

    list.insert(plugin);
  }
  return list;
}


std::auto_ptr<Sql_editor> SqlImpl::getSqlEditor(db_mgmt_RdbmsRef rdbms)
{
  return std::auto_ptr<Sql_editor>(new Sql_editor(rdbms));
}
