#ifndef __SCHEMA_EDITOR_H__
#define __SCHEMA_EDITOR_H__

#include "DBObjectEditorBE.h"
#include "GrtTemplates.h"
#include "editor_schema.h"

#pragma make_public(::bec::SchemaEditorBE)

namespace MySQL {
namespace Grt {
namespace Db {

public ref class SchemaEditorBE : public DBObjectEditorBE
{
protected:
  SchemaEditorBE(::bec::SchemaEditorBE *inn)
    : DBObjectEditorBE(inn)
  {}

public:
  SchemaEditorBE::SchemaEditorBE(MySQL::Grt::GrtManager^ grtm, MySQL::Grt::GrtValue^ args)
  : DBObjectEditorBE(
        new bec::SchemaEditorBE(grtm->get_unmanaged_object(), 
          db_SchemaRef::cast_from(grt::BaseListRef::cast_from(args->get_unmanaged_object()).get(0)), 
          get_rdbms_for_db_object(grt::BaseListRef::cast_from(args->get_unmanaged_object()).get(0)))
      )
  {
  }


  ::bec::SchemaEditorBE *get_unmanaged_object()
  { return static_cast<::bec::SchemaEditorBE *>(inner); }

  void set_schema_option_by_name(System::String^ name, System::String^ value)
  {
    char *name_c_str = Grt::GrtUtil::StringToChar(name);
    char *value_c_str = Grt::GrtUtil::StringToChar(value);

    get_unmanaged_object()->set_schema_option_by_name(std::string(name_c_str), std::string(value_c_str));

    delete name_c_str;
    delete value_c_str;
  }

  String^ get_schema_option_by_name(String^ name)
  {
    char *name_c_str = Grt::GrtUtil::StringToChar(name);
    String^ retval= Grt::GrtUtil::CharToString(get_unmanaged_object()->get_schema_option_by_name(std::string(name_c_str)).c_str());
    delete name_c_str;
    return retval;
  }

};

} // namespace Db
} // namespace Grt
} // namespace MySQL

#endif // __SCHEMA_EDITOR_H__