#include "stdafx.h"

//#pragma warning(disable: 4793)  // 'vararg' causes native code generation

#include "TableEditorBE.h"

namespace MySQL {
namespace Grt {
namespace Db {

TableColumnsListBE::TableColumnsListBE(TableEditorBE^ owner)
  : ListModel(new ::bec::TableColumnsListBE(owner->get_unmanaged_object()))
{}

TableColumnsListBE::TableColumnsListBE(::bec::TableColumnsListBE *inn)
  : ListModel(inn)
{}


bool TableColumnsListBE::get_row(NodeId^ node,
             [Out] String^ %name,
             [Out] String^ %type,
             [Out] bool^ %ispk,
             [Out] bool^ %notnull,
             [Out] String^ %flags,
             [Out] String^ %defvalue,
             [Out] String^ %charset,
             [Out] String^ %collation,
             [Out] String^ %comment)
{
  char *name_c_str = GrtUtil::StringToChar(name);
  char *type_c_str = GrtUtil::StringToChar(type);
  char *flags_c_str = GrtUtil::StringToChar(flags);
  char *defvalue_c_str = GrtUtil::StringToChar(defvalue);
  char *charset_c_str = GrtUtil::StringToChar(charset);
  char *collation_c_str = GrtUtil::StringToChar(collation);
  char *comment_c_str = GrtUtil::StringToChar(comment);

  std::string name_str(name_c_str);
  std::string type_str(type_c_str);
  std::string flags_str(flags_c_str);
  std::string defvalue_str(defvalue_c_str);
  std::string charset_str(charset_c_str);
  std::string collation_str(collation_c_str);
  std::string comment_str(comment_c_str);

  delete name_c_str;
  delete type_c_str;
  delete flags_c_str;
  delete defvalue_c_str;
  delete charset_c_str;
  delete collation_c_str;
  delete comment_c_str;

  bool local_ispk, local_notnull;

  bool retval= get_unmanaged_object()->get_row(*node->get_unmanaged_object(), 
    name_str, 
    type_str, 
    local_ispk, 
    local_notnull, 
    flags_str, 
    defvalue_str, 
    charset_str, 
    collation_str,
    comment_str);

  *ispk= local_ispk;
  *notnull= local_notnull;

  name= GrtUtil::CharToString(name_str.c_str());
  type= GrtUtil::CharToString(type_str.c_str());

  flags= GrtUtil::CharToString(flags_str.c_str());
  defvalue= GrtUtil::CharToString(defvalue_str.c_str());
  charset= GrtUtil::CharToString(charset_str.c_str());
  collation= GrtUtil::CharToString(collation_str.c_str());
  comment= GrtUtil::CharToString(comment_str.c_str());

  return retval;
}

IndexColumnsListBE::IndexColumnsListBE(IndexListBE^ owner)
  : ListModel(new ::bec::IndexColumnsListBE(owner->get_unmanaged_object()))
{}

IndexColumnsListBE::IndexColumnsListBE(::bec::IndexColumnsListBE *inn)
  : ListModel(inn)
{}

void IndexColumnsListBE::set_column_enabled(NodeId^ node, bool flag)
{
 get_unmanaged_object()->set_column_enabled(*node->get_unmanaged_object(), flag); 
}

bool IndexColumnsListBE::get_column_enabled(NodeId^ node)
{
  return get_unmanaged_object()->get_column_enabled(*node->get_unmanaged_object()); 
}

int IndexColumnsListBE::get_max_order_index()
{
  return get_unmanaged_object()->get_max_order_index();
}


IndexListBE::IndexListBE(TableEditorBE^ owner)
  : ListModel(new ::bec::IndexListBE(owner->get_unmanaged_object()))
{}

IndexListBE::IndexListBE(::bec::IndexListBE *inn)
  : ListModel(inn)
{}
  
IndexColumnsListBE^ IndexListBE::get_columns() 
{ return gcnew IndexColumnsListBE(get_unmanaged_object()->get_columns()); }

void IndexListBE::select_index(NodeId^ node)
{ get_unmanaged_object()->select_index(*node->get_unmanaged_object()); }

FKConstraintColumnsListBE::FKConstraintColumnsListBE(FKConstraintListBE^ owner)
  : ListModel(new ::bec::FKConstraintColumnsListBE(owner->get_unmanaged_object()))
{}

FKConstraintColumnsListBE::FKConstraintColumnsListBE(::bec::FKConstraintColumnsListBE *inn)
  : ListModel(inn)
{}

List<String^>^ FKConstraintColumnsListBE::get_ref_columns_list(NodeId^ node)
{
  return CppStringListToNative(
    static_cast<::bec::FKConstraintColumnsListBE *>(inner)->get_ref_columns_list(*node->get_unmanaged_object()));
}

void FKConstraintColumnsListBE::set_column_is_fk(NodeId^ node, bool flag)
{
 get_unmanaged_object()->set_column_is_fk(*node->get_unmanaged_object(), flag); 
}

bool FKConstraintColumnsListBE::get_column_is_fk(NodeId^ node)
{
  return get_unmanaged_object()->get_column_is_fk(*node->get_unmanaged_object()); 
}

FKConstraintListBE::FKConstraintListBE(TableEditorBE^ owner)
  : ListModel(new ::bec::FKConstraintListBE(owner->get_unmanaged_object()))
{}

FKConstraintListBE::FKConstraintListBE(::bec::FKConstraintListBE *inn)
  : ListModel(inn)
{}

/*
NodeId^ FKConstraintListBE::add_column(String^ column_name)
{ 
  char *name_c_str = GrtUtil::StringToChar(column_name);
  NodeId^ retval= gcnew NodeId(&get_unmanaged_object()->add_column(std::string(name_c_str)));
  delete name_c_str;
  return retval;
}*/

void FKConstraintListBE::select_fk(NodeId^ node)
{ get_unmanaged_object()->select_fk(*node->get_unmanaged_object()); }


FKConstraintColumnsListBE^ FKConstraintListBE::get_columns()
{ return gcnew FKConstraintColumnsListBE(get_unmanaged_object()->get_columns()); }



IndexListBE^ TableEditorBE::get_indexes() 
{ return gcnew IndexListBE(get_unmanaged_object()->get_indexes()); }

FKConstraintListBE^ TableEditorBE::get_fks() 
{ return gcnew FKConstraintListBE(get_unmanaged_object()->get_fks()); }


// table options
//...

// column editing
NodeId^ TableEditorBE::add_column(String^ name)
{ 
  char *name_c_str = GrtUtil::StringToChar(name);
  NodeId^ retval= gcnew NodeId(&get_unmanaged_object()->add_column(std::string(name_c_str)));
  delete name_c_str;
  return retval;
}

void TableEditorBE::remove_column(NodeId^ node)
{ get_unmanaged_object()->remove_column(*node->get_unmanaged_object()); }

//db_Column get_column_with_name(const std::string &name);

// fk editing
NodeId^ TableEditorBE::add_fk(String^ name)
{
  char *name_c_str = GrtUtil::StringToChar(name);
  NodeId^ retval= gcnew NodeId(&get_unmanaged_object()->add_fk(std::string(name_c_str)));
  delete name_c_str;
  return retval;
}

void TableEditorBE::remove_fk(NodeId^ node)
{ get_unmanaged_object()->remove_fk(*node->get_unmanaged_object()); }

NodeId^ TableEditorBE::add_fk_with_columns(List<NodeId ^> ^columns)
{
  std::vector<::bec::NodeId> node_vec= ObjectListToCppVector<NodeId, ::bec::NodeId>(columns);
  return gcnew NodeId(&get_unmanaged_object()->add_fk_with_columns(node_vec));
}

// index editing
NodeId^ TableEditorBE::add_index(String^ name)
{
  char *name_c_str = GrtUtil::StringToChar(name);
  NodeId^ retval= gcnew NodeId(&get_unmanaged_object()->add_index(std::string(name_c_str)));
  delete name_c_str;
  return retval;
}

void TableEditorBE::remove_index(NodeId^ node)
{ get_unmanaged_object()->remove_index(*node->get_unmanaged_object()); }

NodeId^ TableEditorBE::add_index_with_columns(List<NodeId ^> ^columns)
{
  std::vector<::bec::NodeId> node_vec= ObjectListToCppVector<NodeId, ::bec::NodeId>(columns);
  return gcnew NodeId(&get_unmanaged_object()->add_index_with_columns(node_vec));
}

List<String^>^ TableEditorBE::get_index_types()
{  
  return CppStringListToNative(
    static_cast<::bec::TableEditorBE *>(inner)->get_index_types());
}


} // namespace Db
} // namespace Grt
} // namespace MySQL
