//
//  WBMainWindow.h
//  MySQLWorkbench
//
//  Created by Alfredo Kojima on 1/Oct/08.
//  Copyright 2008 Sun Microsystems Inc. All rights reserved.
//

#import "sigobjc++.h"
#import <Cocoa/Cocoa.h>
#include "workbench/wb_context_ui.h"

@class WBMainController;
@class GRTShellViewController;
@class WBMenuManager;
@class WBToolbarManager;
@class WBBasePanel;
@class WBOverviewPanel;

@interface WBMainWindow : NSWindowController
{
  IBOutlet NSTextField *statusBarText;

  IBOutlet NSTabView *topTabView;
  IBOutlet NSTabView *bottomTabView;
  
  IBOutlet NSTabView *sideTabView;
  
  IBOutlet NSView *sideToolbar;

  IBOutlet GRTShellViewController *shellController;
  
  NSMutableDictionary *_forms;
  
  WBMainController *_mainController;
  
  WBMenuManager *_menuManager;
  WBToolbarManager *_toolbarManager;
  
  WBOverviewPanel *_overview;
  
  wb::WBContextUI *_wbui;
}

- (void)load;
- (void)setOwner:(WBMainController*)owner;
- (void)setWBContext:(wb::WBContextUI*)wbui;
- (void)setupReady;
- (void)addTopPanel:(WBBasePanel*)panel;
- (GRTShellViewController*)shell;



- (void)refreshGUI:(wb::RefreshType)type
         argument1:(const std::string&)arg1
         argument2:(NativeHandle)arg2;

- (void)setStatusText:(NSString*)text;

- (void)canvasToolChanged:(mdc::CanvasView*)canvas;

- (mdc::CanvasView*)createView:(const char*)oid
                          name:(const char*)name;
- (void)destroyView:(mdc::CanvasView*)view;

@end
