using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using WeifenLuo.WinFormsUI.Docking;
using MySQL.Workbench;
using MySQL.GUI.Workbench.Properties;
using MySQL.GUI.Mdc;
using MySQL.Grt;

namespace MySQL.GUI.Workbench
{
	public partial class DocumentPropertiesForm : DockContent
	{
		#region Member Variables

		protected WbContext wbContext;

		#endregion

		#region Constructor

		public DocumentPropertiesForm(WbContext WbContext)
    {
      wbContext = WbContext;

      InitializeComponent();

			Text = DocumentPropertiesForm.FormCaption;
			TabText = Text;

			initForm();
		}

		#endregion

		#region Properties

		public static String FormCaption
		{
			get { return "Document Properties"; }
		}

		#endregion

		#region Form Implementation

		protected void initForm()
		{ 
	    String caption, version, author, project, dateCreated, dateChanged, description;

			//fetch values from backend
			wbContext.get_doc_properties(out caption, out version, out author, out project, out dateCreated, out dateChanged, out description);

			// set UI-Controls
			captionTextBox.Text = caption;
			versionTextBox.Text = version;
			authorTextBox.Text = author;
			projectTextBox.Text = project;
			try
			{
			  // date-convert for user-specific date/time display
				createdTextBox.Text = DateTime.Parse(dateCreated).ToString("dd-MM-yyyy");
			}
			catch 
			{
				// write plain value from backend if conversion fails
				createdTextBox.Text = dateCreated;
			}
			try
			{
				// date-convert for user-specific date/time display
				changedTextBox.Text = DateTime.Parse(dateChanged).ToString("dd-MM-yyyy");
			}
			catch
			{
				// write plain value from backend if conversion fails
				changedTextBox.Text = dateChanged;
			}
			descriptionTextBox.Text = description;

		}

		private void applyButton_Click(object sender, EventArgs e)
		{
			// write data to backend			
			wbContext.set_doc_properties(captionTextBox.Text, versionTextBox.Text, authorTextBox.Text, projectTextBox.Text, createdTextBox.Text, changedTextBox.Text, descriptionTextBox.Text);

			// close form
			Close();
		}

		private void cancelButton_Click(object sender, EventArgs e)
		{
			// just close form without writing data
			Close();
		}

		#endregion

	}
}