#ifndef _WF_LABEL_H_
#define _WF_LABEL_H_


#include "mforms/label.h"

#include "wf_view.h"

using namespace System;
using namespace Windows::Forms;

namespace MySQL {
  namespace Forms {

    ::System::Drawing::ContentAlignment get_alignment(::mforms::Alignment align)
    {
      switch (align)
      {
      case ::mforms::BottomLeft: return ::System::Drawing::ContentAlignment::BottomLeft;
      case ::mforms::BottomCenter: return ::System::Drawing::ContentAlignment::BottomCenter;
      case ::mforms::BottomRight: return ::System::Drawing::ContentAlignment::BottomRight;
      case ::mforms::MiddleLeft: return ::System::Drawing::ContentAlignment::MiddleLeft;
      case ::mforms::MiddleCenter: return ::System::Drawing::ContentAlignment::MiddleCenter;
      case ::mforms::MiddleRight: return ::System::Drawing::ContentAlignment::MiddleRight;
      case ::mforms::TopLeft: return ::System::Drawing::ContentAlignment::TopLeft;
      case ::mforms::TopCenter: return ::System::Drawing::ContentAlignment::TopCenter;
      case ::mforms::TopRight: return ::System::Drawing::ContentAlignment::TopRight;
      }
      return ::System::Drawing::ContentAlignment::TopLeft;
    }


    public ref class LabelImpl : public ViewImpl
    {
    protected:
      LabelImpl(::mforms::Label *self)
        : ViewImpl(self)
      {
      }

      static bool create(::mforms::Label *self)
      {
        LabelImpl ^label= gcnew LabelImpl(self);

        if (label != nullptr)
        {
          Windows::Forms::Label ^l= gcnew Windows::Forms::Label();
          label->wcontrol= l;
          l->Margin.All= 0;
          l->Padding.All= 0;
          //l->AutoSize= true;
          //l->BackColor= Drawing::Color::Aqua;
          return true;
        }
        return false;
      }

      static void set_style(::mforms::Label *self, ::mforms::LabelStyle style)
      {
        LabelImpl^ label= (LabelImpl^)ObjectImpl::FromUnmanaged(self);

        if (label != nullptr)
        {
          Label ^l= (Label^)label->wcontrol;

          switch (style)
          {
          case ::mforms::NormalStyle:
            l->Font= gcnew System::Drawing::Font(l->Font, System::Drawing::FontStyle::Regular);
            break;
          case ::mforms::BoldStyle: 
            l->Font= gcnew System::Drawing::Font(l->Font, System::Drawing::FontStyle::Bold);
            break;
          }
        }
      }

      static void set_text(::mforms::Label *self, const std::string &text)
      {
        LabelImpl^ label= (LabelImpl^)ObjectImpl::FromUnmanaged(self);

        if (label != nullptr)
        {
          ((Label^)label->wcontrol)->Text= CppStringToNative(text);
        }
      }

      static void set_text_align(::mforms::Label *self, ::mforms::Alignment align)
      {
        LabelImpl^ label= (LabelImpl^)ObjectImpl::FromUnmanaged(self);

        if (label != nullptr)
        {
          ((Label^)label->wcontrol)->TextAlign= get_alignment(align);
        }
      }

    public:
      static void init(Manager ^mgr)
      {
        ::mforms::ControlFactory *f= ::mforms::ControlFactory::get_instance();

        DEF_CALLBACK1(bool, ::mforms::Label*, mgr, f->_label_impl, LabelImpl, create);
        DEF_CALLBACK2(void, ::mforms::Label*, const std::string&, mgr, f->_label_impl, LabelImpl, set_text);
        DEF_CALLBACK2(void, ::mforms::Label*, ::mforms::LabelStyle, mgr, f->_label_impl, LabelImpl, set_style);
        DEF_CALLBACK2(void, ::mforms::Label*, ::mforms::Alignment, mgr, f->_label_impl, LabelImpl, set_text_align);
      }
    };

  };
};


#endif
