#ifndef _WF_TEXTBOX_H_
#define _WF_TEXTBOX_H_

#include <mforms/mforms.h>

#include "wf_view.h"


using namespace System;
using namespace Windows::Forms;

namespace MySQL {
  namespace Forms {

    public ref class TextBoxImpl : public ViewImpl
    {
      static bool create(::mforms::TextBox *self)
      {
        TextBoxImpl ^cb= gcnew TextBoxImpl(self);

        if (cb != nullptr)
        {
          Windows::Forms::TextBox ^tb= gcnew Windows::Forms::TextBox();
          cb->wcontrol= tb;
          tb->Multiline= true;
          tb->AcceptsReturn= true;
          tb->ScrollBars= ScrollBars::Both;
          return true;
        }
        return false;
      }

      static void set_text(::mforms::TextBox *self, const std::string &text)
      {
        TextBoxImpl^ cb= (TextBoxImpl^)ObjectImpl::FromUnmanaged(self);

        if (cb != nullptr)
        {
          ((TextBox^)cb->wcontrol)->Text= CppStringToNative(text);
        }
      }

      static std::string get_text(::mforms::TextBox *self)
      {
        TextBoxImpl^ cb= (TextBoxImpl^)ObjectImpl::FromUnmanaged(self);

        if (cb != nullptr)
        {
          return NativeToCppString(((TextBox^)cb->wcontrol)->Text);
        }
        return "";
      }

      static void set_read_only(::mforms::TextBox *self, bool flag)
      {
         TextBoxImpl^ cb= (TextBoxImpl^)ObjectImpl::FromUnmanaged(self);

        if (cb != nullptr)
        {
          ((TextBox^)cb->wcontrol)->ReadOnly= flag;
        }
      }

      static void set_padding(::mforms::TextBox *self, int pad)
      {
      }

      TextBoxImpl(::mforms::TextBox *text)
        : ViewImpl(text)
      {
      }

    public:
      static void init(Manager ^mgr)
      {
        ::mforms::ControlFactory *f= ::mforms::ControlFactory::get_instance();

        DEF_CALLBACK1(bool, ::mforms::TextBox*, mgr, f->_textbox_impl, TextBoxImpl, create);
        DEF_CALLBACK2(void, ::mforms::TextBox*, const std::string&, mgr, f->_textbox_impl, TextBoxImpl, set_text);
        DEF_CALLBACK2(void, ::mforms::TextBox*, bool, mgr, f->_textbox_impl, TextBoxImpl, set_read_only);
        DEF_CALLBACK2(void, ::mforms::TextBox*, int, mgr, f->_textbox_impl, TextBoxImpl, set_padding);
        DEF_CALLBACK1(std::string, ::mforms::TextBox*, mgr, f->_textbox_impl, TextBoxImpl, get_text);
      }
    };

  };
};

#endif
