#ifndef __MYSQL_RELATIONSHIP_EDITOR_H__
#define __MYSQL_RELATIONSHIP_EDITOR_H__

#include "mysql_relationship_editor.h"
#include "GrtTemplates.h"

#pragma make_public(::RelationshipEditorBE)

#ifdef _MSC_VER
//#include  <vcclr.h> // .net interop helpers
using namespace MySQL::Grt;
using namespace System;
using namespace System::Runtime::InteropServices;
using namespace System::Collections::Generic;
#endif

namespace MySQL {
namespace Grt {
namespace Db {

public ref class MySQLRelationshipEditorBE : public BaseEditor
{
protected:
  MySQLRelationshipEditorBE(::RelationshipEditorBE *inn)
    : BaseEditor(inn)
  {}

public:
  MySQLRelationshipEditorBE::MySQLRelationshipEditorBE(MySQL::Grt::GrtManager^ grtm, MySQL::Grt::GrtValue^ arglist)
  : BaseEditor(
      new ::RelationshipEditorBE(grtm->get_unmanaged_object(), 
        workbench_physical_ConnectionRef::cast_from(grt::BaseListRef::cast_from(arglist->get_unmanaged_object()).get(0))
        )
      )
  {
  }

  ::RelationshipEditorBE *get_unmanaged_object()
  { return static_cast<::RelationshipEditorBE *>(inner); }

  
  void set_caption(String^ caption)
  {
    get_unmanaged_object()->set_caption(NativeToCppString(caption));
  }

  String^ get_caption()
  {
    return CppStringToNative(get_unmanaged_object()->get_caption());
  }

  void set_extra_caption(String^ caption)
  {
    get_unmanaged_object()->set_extra_caption(NativeToCppString(caption));
  }

  String^ get_extra_caption()
  {
    return CppStringToNative(get_unmanaged_object()->get_extra_caption());
  }


  void set_mandatory(bool flag)
  {
    get_unmanaged_object()->set_mandatory(flag);
  }

  bool get_mandatory()
  {
    return get_unmanaged_object()->get_mandatory();
  }

  void set_ref_mandatory(bool flag)
  {
    get_unmanaged_object()->set_ref_mandatory(flag);
  }

  bool get_ref_mandatory()
  {
    return get_unmanaged_object()->get_ref_mandatory();
  }

  void set_to_many(bool flag)
  {
    get_unmanaged_object()->set_to_many(flag);
  }

  bool get_to_many()
  {
    return get_unmanaged_object()->get_to_many();
  }

  void set_comment(String^ comment)
  {
    get_unmanaged_object()->set_comment(NativeToCppString(comment));
  }

  String^ get_comment()
  {
    return CppStringToNative(get_unmanaged_object()->get_comment());
  }

  bool get_visible()
  {
    return get_unmanaged_object()->get_visible();
  }

  bool get_splitted()
  {
    return get_unmanaged_object()->get_splitted();
  }

  void set_visible(bool flag)
  {
    get_unmanaged_object()->set_visible(flag);
  }

  void set_splitted(bool flag)
  {
    get_unmanaged_object()->set_splitted(flag);
  }
};

} // namespace Db
} // namespace Grt
} // namespace MySQL

#endif // __MYSQL_RELATIONSHIP_EDITOR_H__