#ifndef _DB_MYSQL_SQL_SYNC_WRAPPER_H_
#define _DB_MYSQL_SQL_SYNC_WRAPPER_H_


#include "db_mysql_sql_sync.h"
#include "GrtTemplates.h"
#include "SigCSlot.h"


namespace MySQL {
namespace GUI {
namespace Workbench {
namespace Plugins {
namespace DbMySQLSync {


using namespace System;
using namespace System::Runtime::InteropServices;
using namespace System::Collections::Generic;
using namespace MySQL::Grt;
using namespace MySQL::GUI::Workbench::Plugins::Db;

// cannot inherit here from DbMySQLValidationPage wrapper as we did in script export/sync
// because .net doesn't support multiple inheritance (in backend we do inherit)
// here just have to duplicate wrapper methods

public ref class DbMySQLSync : Db_plugin
{
public:
  typedef DelegateSlot0<int, int> Validation_finished_cb;
  typedef DelegateSlot1<int, int, int, int> Validation_step_finished_cb;

private:
  Validation_finished_cb^ _validation_finished_cb;
  Validation_step_finished_cb^ _validation_step_finished_cb;

  ::DbMySQLSync *_inner;

public:
  DbMySQLSync(MySQL::Grt::GrtManager ^grt_manager);
  DbMySQLSync(::DbMySQLSync *inner);

  void set_option(String^ name, String^ value)
  { _inner->set_option(NativeToCppString(name), NativeToCppString(value)); }

  void run_validation()
  { _inner->run_validation(); }

  void validation_finished_cb(Validation_finished_cb::ManagedDelegate ^deleg)
  {
    _validation_finished_cb= gcnew Validation_finished_cb(deleg);
    _inner->validation_finished_cb(_validation_finished_cb->get_slot());
  }

  void validation_step_finished_cb(Validation_step_finished_cb::ManagedDelegate ^deleg)
  {
    _validation_step_finished_cb= gcnew Validation_step_finished_cb(deleg);
    _inner->validation_step_finished_cb(_validation_step_finished_cb->get_slot());
  }

  GrtMessageList^ get_messages_list()
  { return gcnew MySQL::Grt::GrtMessageList(_inner->get_messages_list()); }

  //void update_model_old_names()
  //{ _inner->update_model_old_names(); }

  void start_apply_script_to_db()
  { _inner->start_apply_script_to_db(); }
};

} // namespaces
}
}
}
}

#endif // _DB_MYSQL_SQL_SYNC_WRAPPER_H_