#include "stdafx.h"


#include "wb_plugin_wr.h"


namespace MySQL {
namespace GUI {
namespace Workbench {
namespace Plugins {


using namespace System;
using namespace System::Runtime::InteropServices;
using namespace System::Collections::Generic;
using namespace MySQL::Grt;


Wb_plugin::!Wb_plugin()
{
  if (_owning_inner && _inner)
    delete _inner;
}


void Wb_plugin::grtm(MySQL::Grt::GrtManager ^grt_manager)
{
  _grt_manager= grt_manager;
  _inner->grtm(_grt_manager->get_unmanaged_object());
}


void Wb_plugin::task_msg_cb(Task_msg_cb::ManagedDelegate ^deleg)
{
  _task_msg_cb= gcnew Task_msg_cb(deleg);
  _inner->task_msg_cb(_task_msg_cb->get_slot());
}


void Wb_plugin::task_progress_cb(Task_progress_cb::ManagedDelegate ^deleg)
{
  _task_progress_cb= gcnew Task_progress_cb(deleg);
  _inner->task_progress_cb(_task_progress_cb->get_slot());
}


void Wb_plugin::task_fail_cb(Task_fail_cb::ManagedDelegate ^deleg)
{
  _task_fail_cb= gcnew Task_fail_cb(deleg);
  _inner->task_fail_cb(_task_fail_cb->get_slot());
}


void Wb_plugin::task_finish_cb(Task_finish_cb::ManagedDelegate ^deleg)
{
  _task_finish_cb= gcnew Task_finish_cb(deleg);
  _inner->task_finish_cb(_task_finish_cb->get_slot());
}


Boolean Wb_plugin::get_bool_option(String ^name)
{
  return (0 != _inner->get_int_option(NativeToCppString(name)));
}


Double Wb_plugin::get_double_option(String ^name)
{
  return _inner->get_double_option(NativeToCppString(name));
}


String ^ Wb_plugin::get_string_option(String ^name)
{
  return CppStringToNative(_inner->get_string_option(NativeToCppString(name)));
}


int Wb_plugin::get_int_option(String ^name)
{
  return _inner->get_int_option(NativeToCppString(name));
}


void Wb_plugin::set_option(String ^name, Boolean val)
{
  std::string name_= NativeToCppString(name);
  _inner->set_option(name_, val ? 1 : 0);
}


void Wb_plugin::set_option(String ^name, Double val)
{
  std::string name_= NativeToCppString(name);
  _inner->set_option(name_, val);
}


void Wb_plugin::set_option(String ^name, String ^val)
{
  std::string name_= NativeToCppString(name);
  std::string val_= NativeToCppString(val);
  _inner->set_option(name_, val_);
}


void Wb_plugin::set_option(String ^name, int val)
{
  std::string name_= NativeToCppString(name);
  _inner->set_option(name_, val);
}


};  // namespace Plugins
};  // namespace Workbench
};  // namespace GUI
};  // namespace MySQL
