#ifndef __WB_PLUGIN_WR_H__
#define __WB_PLUGIN_WR_H__


#include "wb_plugin_be.h"
#include "GrtTemplates.h"
#include "SigCSlot.h"


namespace MySQL {
namespace GUI {
namespace Workbench {
namespace Plugins {


using namespace System;
using namespace System::Runtime::InteropServices;
using namespace System::Collections::Generic;
using namespace MySQL::Grt;


public ref class Wb_plugin
{
protected:
  ::Wb_plugin *_inner;
  bool _owning_inner;
  MySQL::Grt::GrtManager ^_grt_manager;

public:
  Wb_plugin() : _owning_inner(true), _inner(NULL) {}
  Wb_plugin(::Wb_plugin *inner) : _owning_inner(true), _inner(inner) {}
  virtual ~Wb_plugin() { this->!Wb_plugin(); }
  !Wb_plugin();

  void owning_inner(bool val) { _owning_inner= val; }

  void grtm(MySQL::Grt::GrtManager ^grt_manager);

  void exec_task() { _inner->exec_task(); }

  typedef MySQL::Grt::DelegateSlot2<int, int,
    int, int,
    std::string, String^> Task_msg_cb;
  typedef MySQL::Grt::DelegateSlot2<int, int,
    float, float,
    std::string, String^> Task_progress_cb;
  typedef MySQL::Grt::DelegateSlot1<int, int,
    std::string, String^> Task_fail_cb;
  typedef MySQL::Grt::DelegateSlot0<int, int> Task_finish_cb;

  void task_msg_cb(Task_msg_cb::ManagedDelegate ^cb);
  void task_progress_cb(Task_progress_cb::ManagedDelegate ^cb);
  void task_fail_cb(Task_fail_cb::ManagedDelegate ^cb);
  void task_finish_cb(Task_finish_cb::ManagedDelegate ^cb);

private:
  Task_msg_cb ^_task_msg_cb;
  Task_progress_cb ^_task_progress_cb;
  Task_fail_cb ^_task_fail_cb;
  Task_finish_cb ^_task_finish_cb;

public:
  Boolean get_bool_option(String ^name);
  Double get_double_option(String ^name);
  String ^ get_string_option(String ^name);
  int get_int_option(String ^name);

  void set_option(String ^name, Boolean val);
  void set_option(String ^name, Double val);
  void set_option(String ^name, String ^val);
  void set_option(String ^name, int val);
};


};  // namespace Plugins
};  // namespace Workbench
};  // namespace GUI
};  // namespace MySQL


#endif // __WB_PLUGIN_WR_H__