@echo off


rem uncomment next line if you wish to run single test
rem set onlymodules=wb_context
rem set onlymodules=wb_model_file
if "%skipmodules%"=="" (
rem if "onlymodules"=="" set skipmodules=wb_context wb_context_low wb_model_file wb_copy_paste
)

if "%user-name%"==""       set user-name=test
if "%password%"==""        set password=test

rem override default params only if not defined (that means default value shouldn't be used)
if not "%host%"==""        set hostparam=--host=%host%
if not "%port%"==""        set portparam=--port=%port%
if not "%user-name%"==""   set user-nameparam=--user-name=%user-name%
if not "%password%"==""    set passwordparam=--password=%password%

if not "%onlymodules%"=="" (
                           set onlymodulesparam=only %onlymodules%
) else (
rem set skipmodulesparam only if onlymodulesparam is not set
if not "%skipmodules%"=="" set skipmodulesparam=skip %skipmodules%
)

if "%tee%"=="" set tee=..\..\..\mysql-gui-win-res\bin\tee.exe


if "%logfile%"=="" set logfile=%~dpn0.log


set workdir=.\tut
set app=..\..\bin\debug\MySQLWorkbenchTutTests.exe

del /q %workdir%\data\wb_options.xml

rem store current folder (will return back later)
pushd .

rem check that work directory exists
cd %workdir% ||goto error_setting_workdir

rem check that test application exists
if not exist %app% goto error_app_not_found

rem check that tee exists
if not exist %tee% goto error_tee_not_found

set cmdline=%app%  %onlymodulesparam% %skipmodulesparam% %hostparam% %portparam% %user-nameparam% %passwordparam%

title Wokbench TUT %onlymodulesparam% %skipmodulesparam% %hostparam% %portparam% %user-nameparam% %passwordparam%
echo Starting TUT tests with command line |  %tee% "%logfile%"
echo %cmdline%  | %tee%  -a "%logfile%"

%cmdline%  | %tee% -a "%logfile%"

echo.

rem find failure messages in log file 
findstr /C:"failed:" "%logfile%"

rem findstr sets errorlevel to 0 if string found
if "%errorlevel%"=="0" (
echo Tests failed
pause
) else (
echo Tests passed
)
goto exit

:error_setting_workdir
echo Cannot change current drive to "%workdir%"
pause
goto exit

:error_app_not_found
echo Cannot find test application "%app%"
pause
goto exit

:error_tee_not_found
echo Cannot find tee application "%app%"
pause
goto exit

:exit
rem this will restore initial folder
popd